-- Golden Crawla v2 by RubyTheMii and CloneFighter
-- Additional coding help from NARbluebear and Sebo2205

freeslot("MT_GOLDCRAWLA", "S_FLINGRING_NOCLIP1", "S_FLINGRING_NOCLIP2", "S_FLINGRING_NOCLIPREMOVE")

states[S_FLINGRING_NOCLIP1] = {SPR_RING, A, 0, A_SetObjectFlags, MF_NOCLIPTHING, 2, S_FLINGRING_NOCLIP2}
states[S_FLINGRING_NOCLIP2] = {SPR_RING, A|FF_ANIMATE, TICRATE, nil, 23, 1, S_FLINGRING_NOCLIPREMOVE}
states[S_FLINGRING_NOCLIPREMOVE] = {SPR_RING, A, 0, A_SetObjectFlags, MF_NOCLIPTHING, 1, S_RING}

// A) PCT (Pee Colored Tank)

-- Teleportation, yay!
addHook("MobjThinker", function(mo)
   if mo and mo.valid and mo.target and mo.target.player
      if mo.state == S_RPOS_TELEPORT5 or mo.state == S_RPOS_TELEPORT6 or mo.state == S_RPOS_TELEPORT7
	     P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z+mo.target.height+64*FRACUNIT)
		 mo.angle = mo.target.player.drawangle
	  end
	  if mo.state == S_RPOS_SPAWNONTARGET
	     if mo.tics >= 85
	        mo.momz = 0
	     end
		 if mo.eflags & MFE_JUSTHITFLOOR
		    mo.state = S_RPOS_DASH
	     end
	  end
	  if mo.state == S_RPOS_DASH
	     mo.flags = $ & ~MF_NOCLIPTHING
	  end
   end
end, MT_GOLDCRAWLA)
	  

-- Damage hook - drop rings
addHook("MobjDamage", function(mo)
   local a = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_FLINGRING)
   local b = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_FLINGRING)
   a.state = S_FLINGRING_NOCLIP1
   b.state = S_FLINGRING_NOCLIP1
   a.angle = P_RandomRange(1, 360)*ANG1
   P_SetObjectMomZ(a, 8*FRACUNIT, false)
   P_SetObjectMomZ(b, 8*FRACUNIT, false)
   P_Thrust(a, a.angle, 5*FRACUNIT)
   P_Thrust(b, InvAngle(a.angle), 5*FRACUNIT)
end, MT_GOLDCRAWLA)

-- Death hook - drop two extra rings for a total of 8
addHook("MobjDeath", function(mo)
   local c = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_FLINGRING)
   local d = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_FLINGRING)
   c.state = S_FLINGRING_NOCLIP1
   d.state = S_FLINGRING_NOCLIP1
   c.angle = P_RandomRange(1, 360)*ANG1
   P_SetObjectMomZ(c, 8*FRACUNIT, false)
   P_SetObjectMomZ(d, 8*FRACUNIT, false)
   P_Thrust(c, c.angle, 5*FRACUNIT)
   P_Thrust(d, InvAngle(c.angle), 5*FRACUNIT)
end, MT_GOLDCRAWLA)

// B) The Good Stuff

-- Kirby compatibility!
if not(kirbyabilitytable)
	rawset(_G, "kirbyabilitytable", {})
end
-- Obtain Stone ability upon consumption.
kirbyabilitytable[MT_GOLDCRAWLA] = 3

-- Henry Stickmin compatibility, as introduced in earlier versions.
addHook("MobjDeath", function(mo, inf)
    if mo.skin == "henry" and mo.valid
       local player = mo.player
       if inf and inf.type == MT_GOLDCRAWLA
          player.failwhy = "Uhh... wow. Is this classified"
          player.failwhy2 = "as a hit and run?"
       end
    end
 end, MT_PLAYER)

-- Recent Tails compatibility - big thanks to BuggieTheBug for helping me out with this!
if not (TN_EnemyCarry)
    rawset(_G, "TN_EnemyCarry", {})
end
-- Bounce the Golden Crawla back up so you can grab it again.
TN_EnemyCarry[MT_GOLDCRAWLA] = {type = "bounce", var = 10*FRACUNIT}

addHook("MobjThinker", function(mo)
   	if mo and mo.valid
		if TN_EnemyCarry[mo.type]
		and TN_EnemyCarry[mo.type].type
		and TN_EnemyCarry[mo.type].type == "bounce"
			if mo.carry and mo.carry.valid
			and mo.carry.player and mo.carry.player.valid
			and mo.carry.player.powers[pw_tailsfly]
				local c = mo.carry
				P_SetObjectMomZ(c, FixedMul(P_GetMobjGravity(c)/FRACUNIT*5/3)*P_MobjFlip(c), true)
			end
		end
		if mo.thrown
			if P_IsObjectOnGround(mo)
			    P_SetObjectMomZ(mo, -mo.momz, true)
				if mo.thrownby and mo.thrownby.valid
				and TN_EnemyCarry[mo.type]
				and TN_EnemyCarry[mo.type].type
				and TN_EnemyCarry[mo.type].type == "bounce"
					local pp = mo.thrownby
					P_StartQuake(10*FRACUNIT, TICRATE/2)
					P_Earthquake(mo, pp, 800*FRACUNIT)
					mo.momx = 0
					mo.momy = 0
				    P_DamageMobj(mo, pp)
				end
			else
				P_SetObjectMomZ(mo, P_GetMobjGravity(mo)*P_MobjFlip(mo), true) --Increase gravity (1)
			end
		end
	end
end)
   